#ifndef __LS_HH__
#define __LS_HH__

#include "opt.hh"
#include "snode.hh"
#include "sched.hh"
#include "archi.hh"
#include "pudag.hh"
#include "nodeattr.hh"
#include "zset.hh"
#include "matcher.hh"
#include "flags.hh"

class ListSchedule : public Optimizer {

public:
  ListSchedule(Architecture *);
  ~ListSchedule();

  Schedule *schedule(DAG &, Flags &);

private:
  NodeAttr *get_init_node_attr(ZSet &, DAG &);
  NodeAttr *select(const vertex_set_t &, const NodeAttr &, ZSet &, DAG &);
  SNode *find_ls_match(SNode *, Matcher &, ZSet &, DAG &);
  Architecture *architecture;

};

#endif //__LS_HH__
